<?php
/**
* LocateByAttribute class
*
* @project     CWC2
* @revision    $Id: LocateByAttribute.widget.php,v 1.6 2006/01/31 07:27:39 jdelfos Exp $
* @purpose     Find objects on basis of an attribute value, and zoom to the results
* @author      Jacob Delfos (Maunsell Australia; jacob.delfos@maunsell.com)
* @copyright
* <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
* Permission is hereby granted, free of charge, to any person obtaining a
* copy of this software and associated documentation files (the "Software"),
* to deal in the Software without restriction, including without limitation
* the rights to use, copy, modify, merge, publish, distribute, sublicense,
* and/or sell copies of the Software, and to permit persons to whom the
* Software is furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included
* in all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
* THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
* DEALINGS IN THE SOFTWARE.
*/

include_once(dirname(__FILE__)."/../Widget.php");

/**
* LocateByAttribute Widget
*
* @desc A widget that puts an IFRAME or link to popup in the page, which has 
*       input elements that allow a user to find the objects with a specific 
*       value for a selected attribute.
*
*       TODO: 
*       - when projection is changed on-the-fly without submitting, the 
*         zoom-to results will have invalid coordinates.
*       - add support for other formats (postgis, tiles)
*/
/**
* LocateByAttribute Widget
*
* @desc A widget that puts an IFRAME or link to popup in the page, which has input
*       elements that allow a user to find the objects with a specific 
*       value for a selected attribute.
*/
class LocateByAttribute extends CWCWidget
{

   function LocateByAttribute ()
   {
   parent::CWCWidget();

   //$this->maAttributes["MAPFILE"] = new StringAttribute( "MAPFILE", true ); //in case you want to use a different mapfile for layer definitions
   $this->maAttributes["HEIGHT"] = new StringAttribute( "HEIGHT", true );
   $this->maAttributes["WIDTH"] = new StringAttribute( "WIDTH", true );
   $this->maAttributes["SEARCHALL"] = new StringAttribute( "SEARCHALL", false );
   $this->maAttributes["ZOOMBUFFER"] = new StringAttribute( "ZOOMBUFFER", false );
   $this->maAttributes["POPUP"] = new StringAttribute( "POPUP", false );
   $this->maAttributes["LINKTEXT"] = new StringAttribute( "LINKTEXT", false );
   $this->maAttributes["ALLOWDOWNLOAD"] = new StringAttribute( "ALLOWDOWNLOAD", false );
   $this->maAttributes["HIGHLIGHT"] = new StringAttribute( "HIGHLIGHT", false );
   $this->maAttributes["MAXNUMRESULTS"] = new StringAttribute( "MAXNUMRESULTS", false );
   $this->mnMaturityLevel = MATURITY_BETA;
   }



   function InitDefaults()
   {
   parent::InitDefaults();

   }


    function GetJavascriptFunctions()
    {

        if (isset($this->maSharedResourceWidgets["CWCJSAPI"]))
          $bCWCJSAPI = 1;
        else
          $bCWCJSAPI = 0;


        $szJsFunctionName = "applyBoundingBox";
        $szFunction = <<<EOT
/**
 * {$szJsFunctionName}
 * This function has been copied from the BoundingBox widget
 */
function {$szJsFunctionName}(nMinX, nMinY, nMaxX, nMaxY)
{
    szCoords = "" + nMinX + "," + nMinY;
    if (nMaxX != "" && nMaxY != "")
    {
        szType = "RECTANGLE";
        szCoords = szCoords + "," + nMaxX + "," + nMaxY;
    }
    else
    {
        szType = "POINT";
    }
    {$this->mszHTMLForm}.NAV_CMD.value="ZOOM_BBOX";
    {$this->mszHTMLForm}.NAV_INPUT_TYPE.value=szType;
    {$this->mszHTMLForm}.NAV_INPUT_COORDINATES.value=szCoords;
    
    if (arguments.length == 5)
    {
        {$this->mszHTMLForm}.NAV_INPUT_SRS.value=arguments[4];    
    }

    if ({$bCWCJSAPI})
    {
        goCWCJSAPI.NAV_CMD="ZOOM_BBOX";
        goCWCJSAPI.NAV_INPUT_TYPE = szType;
        goCWCJSAPI.NAV_INPUT_COORDINATES=szCoords;
        if (arguments.length == 5)
        {
            goCWCJSAPI.NAV_INPUT_SRS=arguments[4];
        }
        goCWCJSAPI.UpdateNavTools();
    }
    else
    {
        {$this->mszHTMLForm}.submit();
    }
     return;
}
EOT;

        $aReturn[$szJsFunctionName] = $szFunction;





        $szJsFunctionName = "goToRectangle";
        $szFunction = <<<EOT
/**
 * {$szJsFunctionName}
 * This function goes to bounding coordinates, but keeps the navigation info correct
 */
function {$szJsFunctionName} (minx, miny, maxx, maxy)
{
    if (gCWCJSAPI)
    {
    temp = goCWCJSAPI.NAV_CMD;
    }

   if ((minx==maxx) || (miny == maxy))
   {
   applyBoundingBox(minx, miny, "","");
   }
   else
   {
   applyBoundingBox(minx, miny, maxx, maxy);
   }
   
    if (gCWCJSAPI)
    {
    goCWCJSAPI.NAV_CMD = temp; 
    document.forms[0].NAV_CMD.value = temp;  
    }
}
EOT;

        $aReturn[$szJsFunctionName] = $szFunction;



        $szJsFunctionName = "zoomToPoint";
        $szFunction = <<<EOT
/**
 * {$szJsFunctionName}
 * This function recenters the map on a point
 */
function {$szJsFunctionName} (x, y)
{
    if (gCWCJSAPI)
    {
    temp = goCWCJSAPI.NAV_CMD;
    }

applyBoundingBox(x, y, "","");

    if (gCWCJSAPI)
    {
    goCWCJSAPI.NAV_CMD = temp; 
    document.forms[0].NAV_CMD.value = temp;  
    }
}
EOT;

        $aReturn[$szJsFunctionName] = $szFunction;


        return $aReturn;
    }




    /**
     * DrawPublish
     *
     * Return the HTML code using the name in the map file and the
     * parameters of the CWC tag.
     */
    function DrawPublish()
    {
        if (isset($this->maSharedResourceWidgets["CWCJSAPI"]))
          $bCWCJSAPI = 1;
        else
          $bCWCJSAPI = 0;

   
        if (!$this->mbVisible)
            return "<!-- LocateByAttribute widget hidden -->";
        else
        $objectheight = $this->maParams["HEIGHT"];
        $objectwidth = $this->maParams["WIDTH"];
        
           if (isset($this->maParams["SEARCHALL"]))
           {
           $searchall = $this->maParams["SEARCHALL"];
           }
           else
           {
           $searchall = "false";
           }
           if (isset($this->maParams["ZOOMBUFFER"]))
           {
           $pointzoombuffer = $this->maParams["ZOOMBUFFER"];
           }
           else
           {
           $pointzoombuffer = "false";
           }
           
           if ((isset($this->maParams["POPUP"])) && (strcasecmp($this->maParams["POPUP"],"true") == 0))
           {
           $launchpopup=true;
           }
           else
           {
           $launchpopup = false;
           }        

           if ((isset($this->maParams["LINKTEXT"])) && ($this->maParams["LINKTEXT"] != ""))
           {
           $linktext=$this->maParams["LINKTEXT"];
           }
           else
           {
           $linktext = "Locate by Attributes";
           } 
           
           if ((isset($this->maParams["ALLOWDOWNLOAD"])) && (strcasecmp($this->maParams["ALLOWDOWNLOAD"],"true") == 0))
           {
           $allowdownload=true;
           }
           else
           {
           $allowdownload = "false";
           }    

           if ((isset($this->maParams["HIGHLIGHT"])) && (strcasecmp($this->maParams["HIGHLIGHT"],"true") == 0))
           {
           $highlight=true;
           }
           else
           {
           $highlight = "false";
           }  

           if ((isset($this->maParams["MAXNUMRESULTS"])) && ($this->maParams["MAXNUMRESULTS"]) > 0)
           {
           $maxnumresults = $this->maParams["MAXNUMRESULTS"];
           }
           else
           {
           $maxnumresults = 0;
           }               
                                    
         
           // build URL based on input
           $searchPageURL = $_SESSION['gszCoreWebPath']."/widgets/LocateByAttribute/search.phtml?".SID;
   
           if ($bCWCJSAPI==1)
           {
           $searchPageURL .= "&usejavascript=true";
           }

           if (strcmp(strtolower($searchall), "true") == 0)   
           {
           $searchPageURL .= "&searchall=true";
           }
           if (isset($this->maParams["ZOOMBUFFER"]))
           {
           $searchPageURL .= "&pointzoombuffer=".$pointzoombuffer;
           }
           if ($highlight === true)
           {
           $searchPageURL .= "&highlight=true";
           }
           if ($allowdownload === true)
           {
           $searchPageURL .= "&allowdownload=true";
           } 
           if ($maxnumresults > 0)
           {
           $searchPageURL .= "&maxnumresults=".$maxnumresults;
           } 
            
                                

           // now determine whether to search from IFRAME or POPUP
           if ($launchpopup == true)
           {
           $searchPageURL .= "&launchpopup=true";
           $widgetCode = "<script>function openSearchWindow() {win = window.open('".$searchPageURL."','Searchwindow', 'width=".$objectwidth." ,height=".$objectheight.", menubar,scrollbars,resizable'); } </script>\n\n";
           $widgetCode .= "<A HREF='javascript:openSearchWindow();'>".$linktext."</A>";
           } 
           else
           {
           $widgetCode = "<IFRAME ID='searchByLocation' BORDER=0 HEIGHT=".$objectheight." WIDTH=".$objectwidth." FRAMEBORDER=0 SRC='".$searchPageURL."'></IFRAME>";
           }

        
        return $widgetCode;
    }

}
?>
